package com.cool.bang.modules.mysql.service;

import com.cool.bang.common.util.DateUtil;
import com.cool.bang.modules.mysql.domain.*;
import com.cool.bang.modules.mysql.domain.flowPo.ApprovalFlow;
import com.cool.bang.modules.mysql.domain.flowPo.ApprovalNode;
import com.cool.bang.modules.mysql.domain.flowPo.ApprovalRecord;
import com.cool.bang.modules.mysql.mapper.*;
import com.cool.bang.modules.oracle.domain.Areg;
import com.cool.bang.modules.oracle.domain.AregItem;
import com.cool.bang.modules.oracle.domain.Bxmxy;
import com.cool.bang.modules.oracle.domain.Trade;
import com.cool.bang.modules.oracle.domain.po.*;
import com.cool.bang.modules.oracle.mapper.*;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.util.ObjectUtils;
import org.springframework.util.StringUtils;

import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;
import java.util.stream.Stream;

@Service
public class MySQLSecondService {

    @Autowired
    private MySqlMapper mySqlMapper;
    @Autowired
    private OracleMapper oracleMapper;
    @Autowired
    private OrgMapper qyxxMapper;
    @Autowired
    private AccountMapper accountMapper;
    ;
    @Autowired
    private ProjectAccountMapper projectAccountMapper;
    @Autowired
    private BuildingAccountMapper buildingAccountMapper;


    /**
     * 定金导入
     */
    @Transactional
    public void refundTo() {
        System.out.println("===============fc_refund 导入数据开始=================");
        //List<TkInfo> djTkList = oracleMapper.selectDjTk();
        List<TkInfo> htTkList = oracleMapper.selectHtTk();
        /*List<Integer> otherHtIds = new ArrayList<>();
        otherHtIds.add(40051);
        otherHtIds.add(3958);
        otherHtIds.add(13496);
        otherHtIds.add(19046);*/

        //List<TkInfo> otherChange = oracleMapper.selectOtherHtTk(otherHtIds);
        //List<TkInfo> tkInfoList = Stream.concat(djTkList.stream(), htTkList.stream()).collect(Collectors.toList());
        //tkInfoList = Stream.concat(tkInfoList.stream(), otherChange.stream()).collect(Collectors.toList());
        List<Refund> refunds = new ArrayList<>();
        for (TkInfo item : htTkList) {
            Integer qybh = StringUtils.isEmpty(item.getQybh()) ? null : Integer.valueOf(item.getQybh());
            Org org = qyxxMapper.selectOrgByMisid(qybh);
            if (org == null) { //测试用
                org = new Org();
                org.setId(3);
                org.setOrgName("山东酷邦软件有限公司");
            }
            BuildingAccount buildingAccount = null;
            if (!StringUtils.isEmpty(item.getLzbh())) {
                buildingAccount = buildingAccountMapper.getInfoByLZBH(item.getLzbh());
            }
            Long projectAccountId = (null != buildingAccount && null != buildingAccount.getProjectAccountId()) ? buildingAccount.getProjectAccountId() : null;
            ProjectAccount projectAccount = null;
            if (null != projectAccountId) {
                projectAccount = projectAccountMapper.getInfoById(projectAccountId);
            }
            Account account = null;
            if (!StringUtils.isEmpty(item.getAccountNo())) {
                account = accountMapper.selectByAccountNO(item.getAccountNo());
            }
            ContractInfo contract = null;
            if (!StringUtils.isEmpty(item.getHtBh())) {
                contract = mySqlMapper.getInfoByNumber(item.getHtBh());
            }
            Refund refund = new Refund(item, org, projectAccount, account, contract, buildingAccount);
            //定金退款的
            if (null == item.getMoney()) {
                refund.setAppropriationStatus("0");
            } else {
                refund.setAppropriationStatus("1");
            }
            refunds.add(refund);
        }
        mySqlMapper.insertRefund(refunds);
        System.out.println("===============fc_refund数据匹配结束=================");
    }


    @Transactional
    public void tradeDDZTo() {
        System.out.println("===============fc_trade 导入数据开始=================");
        List<TradeInfo> tradeInfoList = oracleMapper.selectDDZ();
        List<FcTrade> fcTrades = new ArrayList<>();

        for (TradeInfo item : tradeInfoList) {
            BuildingAccount buildingAccount = null;
            if (!StringUtils.isEmpty(item.getLzbh())) {
                buildingAccount = buildingAccountMapper.getInfoByLZBH(item.getLzbh());
            }
            Long projectAccountId = (null != buildingAccount && null != buildingAccount.getProjectAccountId()) ? buildingAccount.getProjectAccountId() : null;
            ProjectAccount projectAccount = null;
            if (null != projectAccountId) {
                projectAccount = projectAccountMapper.getInfoById(projectAccountId);
            }
            Account account = null;
            if (!StringUtils.isEmpty(item.getAccountNo())) {
                account = accountMapper.selectByAccountNO(item.getAccountNo());
            }

            FcTrade fcTrade = new FcTrade(item, projectAccount, account, buildingAccount);

            fcTrades.add(fcTrade);
        }
        mySqlMapper.insertFcTrade(fcTrades);
        System.out.println("===============fc_trade数据匹配结束=================");
    }

    @Transactional
    public void tradeTgTo() {
        System.out.println("===============fc_trade 导入数据开始=================");
        List<TradeInfo> tradeInfoList = oracleMapper.selectTG();
        List<FcTrade> fcTrades = new ArrayList<>();

        for (TradeInfo item : tradeInfoList) {
            BuildingAccount buildingAccount = null;
            if (!StringUtils.isEmpty(item.getLzbh())) {
                buildingAccount = buildingAccountMapper.getInfoByLZBH(item.getLzbh());
            }
            Long projectAccountId = (null != buildingAccount && null != buildingAccount.getProjectAccountId()) ? buildingAccount.getProjectAccountId() : null;
            ProjectAccount projectAccount = null;
            if (null != projectAccountId) {
                projectAccount = projectAccountMapper.getInfoById(projectAccountId);
            }
            Account account = null;

            if (!StringUtils.isEmpty(item.getAccountNo())) {
                account = accountMapper.selectByAccountNO(item.getAccountNo());
            }

            FcTrade fcTrade = new FcTrade(item, projectAccount, account, buildingAccount);

            fcTrades.add(fcTrade);
        }
        mySqlMapper.insertFcTrade(fcTrades);
        System.out.println("===============fc_trade数据匹配结束=================");
    }

    /**
     * 对账
     */
    public void accountChecking() {
        List<Map<String, Object>> tgXm = mySqlMapper.selectTgXm();
        List<String> list = new ArrayList<>();
        for (Map<String, Object> map : tgXm) {
            List<Map<String, Object>> xmAccount = mySqlMapper.selectXmAccountByProjectId((Long) map.get("id"));
            for (Map<String, Object> account : xmAccount) {
                List<Map<String, Object>> buildingInfo = mySqlMapper.selectBuildingBy((Long) map.get("id"), (Long) account.get("id"));
                for (Map<String, Object> building : buildingInfo) {
                    //监管转托管
                    BigDecimal zgToTg = oracleMapper.sumByZgToTg((String) (building.get("building_number")));
                    zgToTg = null == zgToTg ? BigDecimal.ZERO : zgToTg;
                    //交存
                    BigDecimal jc = oracleMapper.sumByJc((String) building.get("building_number"));
                    jc = null == jc ? BigDecimal.ZERO : jc;
                    //拨付
                    BigDecimal bf = oracleMapper.sumByBf((String) building.get("building_number"));
                    bf = null == bf ? BigDecimal.ZERO : bf;

                    BigDecimal accountBalance = mySqlMapper.getAccountBalanceByNumber((String) building.get("building_number"));
                    accountBalance = accountBalance == null ? BigDecimal.ZERO : accountBalance;
                    BigDecimal hj = (zgToTg.add(jc)).subtract(bf);
                    StringBuilder str = new StringBuilder();
                    String buildingName = String.valueOf(building.get("building_name"));
                    BigDecimal cz = BigDecimal.ZERO;
                    if (!(hj.compareTo(accountBalance) == 0)) {
                        cz = hj.subtract(accountBalance);
                    }
                    str.append(building.get("project_name").toString())
                            .append(";" + building.get("project_number").toString())
                            .append(";" + buildingName)
                            .append(";" + building.get("building_number").toString())
                            .append(";" + zgToTg)
                            .append(";" + jc)
                            .append(";" + bf)
                            .append(";" + hj)
                            .append(";" + accountBalance)
                            .append(";" + (hj.compareTo(accountBalance) == 0 ? "是" : "否"))
                            .append(";" + (hj.compareTo(accountBalance) == 0 ? "" : cz));
                    System.out.println(str.toString());
                    list.add(str.toString());
                }
            }
        }
        for (String str : list) {
            System.out.println(str);
        }
    }

    /**
     * 银行账户对账
     */
    public void bankAccountChecing() {
        List<Account> list = mySqlMapper.selectTgAccountInfo();
        List<Account> wdzJc = oracleMapper.getWdzJc();
        List<Account> wdzBf = oracleMapper.getWdzBf();
        List<String> strs = new ArrayList<>();
        for (Account account : list) {
            //未对账的交存
            BigDecimal jc = BigDecimal.ZERO;
            if (wdzJc != null && !wdzJc.isEmpty()) {
                Account jcAccount = wdzJc.stream().filter(t -> !StringUtils.isEmpty(t.getBankCode()) && t.getBankCode().equals(account.getBankCode())).findFirst().orElse(null);
                jc = null != jcAccount ? jcAccount.getBalance() : BigDecimal.ZERO;
            }
            //未对账的拨付
            BigDecimal bf = BigDecimal.ZERO;
            if (wdzBf != null && !wdzBf.isEmpty()) {
                Account bfAccount = wdzBf.stream().filter(t -> !StringUtils.isEmpty(t.getBankCode()) && t.getBankCode().equals(account.getBankCode())).findFirst().orElse(null);
                bf = null != bfAccount ? bfAccount.getBalance() : BigDecimal.ZERO;
            }
            StringBuilder str = new StringBuilder();
            str.append(account.getBankName())
                    .append(";" + account.getBankCode())
                    .append(";" + jc)
                    .append(";" + bf)
                    .append(";" + account.getBalance())
                    .append(";" + account.getAccountBalance())
                    .append(";" + ((account.getBalance().subtract(jc)).add(bf)).subtract(account.getAccountBalance()));
            strs.add(str.toString());
        }

        for (String str : strs) {
            System.out.println(str);
        }
    }
}
